<template>
	<ProviderCustomColors
		:id="id"
		v-bind="getColorProps($props)"
		:class="$style.b2bTestimonials"
		:style="{ backgroundColor }"
	>
		<MoleculeCarousel
			ref="carousel"
			:class="$style.carousel"
			:has-navigation="false"
			:has-pagination="hasPagination"
			:autoplay="false"
			@slidechanged="handleSlideChanged"
		>
			<MoleculeCarouselSlide v-for="(slide, index) in items" :key="index" :class="$style.slide" :slide-index="index">
				<BlockB2BTestimonialsView
					ref="testimonial"
					:slide="slide"
					:set-timer="currentSlide === index"
					@ended="nextSlide"
				></BlockB2BTestimonialsView>
			</MoleculeCarouselSlide>
		</MoleculeCarousel>

		<div v-if="logos.length > 0" :class="$style.logosDesktop">
			<button
				v-for="(logo, index) in logos"
				:key="index"
				:class="[$style.logoDesktop, { [$style.isActive]: currentSlide === index }]"
				@click="switchSlide(index)"
			>
				<BaseImage :image="logo" fit contain compression-level="high" sizes="" />
			</button>
		</div>
	</ProviderCustomColors>
</template>

<script>
import ProviderCustomColors, { getColorProps } from '@components/provider-custom-colors';
import MoleculeCarousel from '@components/molecule-carousel';
import MoleculeCarouselSlide from '@components/molecule-carousel-slide';
import BlockB2BTestimonialsView from '@components/block-b2b-testimonials-view';

export default {
	components: {
		ProviderCustomColors,
		MoleculeCarousel,
		MoleculeCarouselSlide,
		BlockB2BTestimonialsView,
	},

	props: {
		id: {
			type: String,
			default: null,
		},

		items: {
			type: Array,
			default: () => [],
		},

		backgroundColor: {
			type: String,
			default: '',
		},

		copyColor: {
			type: String,
			default: '',
		},
	},

	data: () => ({ currentSlide: 0 }),

	computed: {
		logos() {
			return this.items.map((item) => (item.logo && Object.keys(item.logo).length ? item.logo : false)).filter(Boolean);
		},
		hasPagination() {
			return this.items.length > 1;
		},
	},

	methods: {
		getColorProps,

		switchSlide(i) {
			this.$refs.carousel.switchSlide(i);
		},

		handleSlideChanged(currentIndex) {
			this.currentSlide = currentIndex;
			this.$refs.testimonial[currentIndex].activeTimer();
		},

		nextSlide() {
			this.$refs.carousel.switchSlide(this.currentSlide + 1);
		},
	},
};
</script>

<style lang="scss" module>
@import '@design';

.b2bTestimonials {
	padding: 0 0 4.9rem;

	@include above('medium') {
		padding: 12rem 5rem 6rem;
	}

	@include above('large') {
		padding: 12rem 11rem 4rem;
	}
}

.carousel {
	@include above('medium') {
		padding: 0 0 6rem;
	}
}

.slide {
	padding: 6.9rem 4rem 2.7rem;
	text-align: center;

	@include above('medium') {
		padding: 0;
	}
}

.logosDesktop {
	display: flex;
	justify-content: center;
	height: 7.8rem;

	@include below('medium') {
		display: none;
	}
}

.logoDesktop {
	position: relative;
	flex: 1;
	opacity: 0.5;

	@include transition('fade');

	&.isActive {
		opacity: 1;
	}
}

.b2bTestimonials [class^='carousel'] + [class^='wrapper'] {
	@include above('medium') {
		display: none;
	}
}
</style>
